/*
 File: dbl_colon.h
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#ifndef __dbl_colon_h__
#define __dbl_colon_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
extern yacco2::Thread_entry ITH_dbl_colon;

extern yacco2::State S1_Cdbl_colon;
namespace NS_dbl_colon {
yacco2::THR _YACCO2_CALL_TYPE
TH_dbl_colon(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_dbl_colon(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[1];
};
class Cdbl_colon: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rdbl_colon_ = 569//start_of_rule_list + 0
    ,rhs1_Rdbl_colon_ = 1
  };
  //no of la sets = 1
  //no of states = 3
  Cdbl_colon();
  ~Cdbl_colon();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[2];
 };
struct Rdbl_colon;
struct Rdbl_colon:public yacco2::CAbs_lr1_sym {
  Rdbl_colon(yacco2::Parser* P);
  void op();

      public:
      CAbs_lr1_sym* rtn_sym_;
    
  public:
  void sr1();
};

} // end of namespace

#endif
